"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ExampleMiscLayer = exports.Primary = exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _2 = _interopRequireDefault(require("./"));

var _tesla = _interopRequireDefault(require("./tesla.json"));

var _useColors = require("../../hooks/use-colors");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var _default = {
  title: "MainLayout",
  component: _2.default,
  argTypes: {}
};
exports.default = _default;

var Primary = function Primary() {
  var _useState = (0, _react.useState)([{
    label: "buy here",
    color: _useColors.solarized.cyan,
    durations: [{
      start: 1537416000000,
      end: 1539316800000
    }]
  }, {
    label: "sell here",
    color: _useColors.solarized.magenta,
    durations: []
  }]),
      _useState2 = _slicedToArray(_useState, 2),
      durationGroups = _useState2[0],
      setDurationGroups = _useState2[1];

  var _useState3 = (0, _react.useState)([{
    color: _useColors.solarized.red,
    time: 1520398800000
  }]),
      _useState4 = _slicedToArray(_useState3, 2),
      timestamps = _useState4[0],
      setTimestamps = _useState4[1];

  return /*#__PURE__*/_react.default.createElement(_2.default, {
    timeFormat: "dates",
    curveGroups: [[{
      data: _tesla.default.curve2018,
      color: _useColors.solarized.yellow
    }, {
      data: _tesla.default.curve2017,
      color: _useColors.solarized.blue
    }], [{
      data: _tesla.default.curve2017.concat(_tesla.default.curve2018).filter(function (_, i) {
        return i % 10 === 0;
      }).sort(function (a, b) {
        return a[0] - b[0];
      }),
      color: _useColors.solarized.green
    }]],
    durationGroups: durationGroups,
    timestamps: timestamps,
    onChangeTimestamps: setTimestamps,
    onChangeDurationGroups: setDurationGroups
  });
};

exports.Primary = Primary;

var ExampleMiscLayer = function ExampleMiscLayer() {
  var _useState5 = (0, _react.useState)([{
    color: _useColors.solarized.cyan,
    durations: [{
      start: 1537416000000 - 1000 * 60 * 60 * 24 * 40,
      end: 1539316800000 - 1000 * 60 * 60 * 24 * 40,
      label: "one"
    }, {
      start: 1537416000000,
      end: 1539316800000,
      label: "two"
    }]
  }]),
      _useState6 = _slicedToArray(_useState5, 2),
      durationGroups = _useState6[0],
      setDurationGroups = _useState6[1];

  return /*#__PURE__*/_react.default.createElement(_2.default, {
    timeFormat: "dates",
    curveGroups: [[{
      data: _tesla.default.curve2018,
      color: _useColors.solarized.yellow
    }]],
    timestamps: [],
    durationGroups: durationGroups,
    onChangeTimestamps: function onChangeTimestamps() {
      return null;
    },
    onChangeDurationGroups: function onChangeDurationGroups(newDurationGroups) {
      console.log(newDurationGroups.asMutable());
      setDurationGroups(newDurationGroups);
    }
  });
};

exports.ExampleMiscLayer = ExampleMiscLayer;